/*****************************************************************************
*					}WbNpPbgMTv(IPv4p)                   *
*                                                                            *
*@쐬    FMicrosoft Visual C++ 2010 Express                           *
*@mFnrFWindows XP Professional (32bit)                             *
*@@@@@@@@Windows 7 Professional (64bit)                              *
*                                                     2012.11.28 create nPYO *
*****************************************************************************/

/* Aṽo[W			*/
#define APP_VERSION "0.01"

/* ftHg̎gp|[gԍ		*/
#define DEFAULT_PORT 9

/* ftHg̑MIPAhX		*/
#define DEFAULT_IP "255.255.255.255"

/* gpwinsock̃o[W		*/
#define USE_WINSOCK_VER 2					/* 1 or 2		*/

/* winsockgpׂ̈̐ݒ			*/
#if ( USE_WINSOCK_VER == 1 )
#pragma comment( lib, "WSOCK32.lib" )
#include <winsock.h>
#elif ( USE_WINSOCK_VER == 2 )
#pragma comment( lib, "WS2_32.lib" )
#include <winsock2.h>
#endif

/* }WbNpPbgf[^\`	*/
#define HEADER_LENGTH 6
#define MAC_ADDRESS_LENGTH 6
#define REPEAT_COUNT 16

#include <stdio.h>
#include <string.h>

/*****************************************************************************
*						10iȂ̂mF
* Fchar *str 
* ߒlFint       0:10ił͂Ȃ
*				  1:10ił
*****************************************************************************/
int isDecimalNumberString( char *str )
{
	unsigned char c;
	while ( *str ) {
		c = *str++;
		if ( ( c < '0' ) || ( c > '9' ) ) {
			return ( 0 );
		}
	}
	return ( 1 );
}

/*****************************************************************************
*						16iȂ̂mF
* Fchar *str 
* ߒlFint       0:16ił͂Ȃ
*				  1:16ił
*****************************************************************************/
int isHexNumberString( char *str )
{
	unsigned char c;

	while ( *str ) {
		c = *str++;
		if ( !( ( ( c >= '0' ) && ( c <= '9' ) ) || ( ( c >= 'A' ) && ( c <= 'F' ) ) || ( ( c >= 'a' ) && ( c <= 'f' ) ) ) ) {
			return ( 0 );
		}
	}
	return ( 1 );
}

/*****************************************************************************
*					MACAhXoCgzɕϊ
* Fchar          *str ( "00:00:00:00:00:00" / "00-00-00-00-00-00" )
*		unsigned char *mac MACAhXf[^(6bytes)
* ߒlFint                0:OK !0:NG
*****************************************************************************/
int aton_mac_addr( char *str ,unsigned char *mac )
{
	int i;
	unsigned char macValue[ MAC_ADDRESS_LENGTH ];
	char buf[ 4 ] ,*p;

	/* 񒷃`FbN				*/
	if ( strlen( str ) != ( ( MAC_ADDRESS_LENGTH * 3 ) - 1 ) ) {
		return ( 1 );
	}

	/* ؂蕶̃`FbN			*/
	if ( ( str[ 2 ] != ':' ) || ( str[ 5 ] != ':' ) || ( str[ 8 ] != ':' ) || ( str[ 11 ] != ':' ) || ( str[ 14 ] != ':' ) ) {
		if ( ( str[ 2 ] != '-' ) || ( str[ 5 ] != '-' ) || ( str[ 8 ] != '-' ) || ( str[ 11 ] != '-' ) || ( str[14] != '-' ) ) {
			return ( 2 );
		}
	}

	for ( i = 0 ;i < MAC_ADDRESS_LENGTH ;i++ ) {

		/* MACAhX\vf1擾	*/
		memcpy( buf ,str ,2 );
		buf[ 2 ] = '\0';
		str += 3;

		/* 16i񂩂`FbN		*/
		if ( isHexNumberString( buf ) == 0 ) {
			return ( 3 );
		}

		/* 𐔒lɕϊ			*/
		macValue[ i ] = (unsigned char)strtol( buf ,&p ,16 );
	}

	memcpy( mac ,macValue ,MAC_ADDRESS_LENGTH );

	return ( 0 );
}

/*****************************************************************************
*						IPAhXlɕϊ
* Fchar          *str 
*		unsigned long *ip  ʂԂϐւ̃|C^
* ߒlFint                0:OK !0:NG
*****************************************************************************/
int aton_ip_addr( char *str ,unsigned long *ip )
{
	char buf[ 256 ];
	char *tok ,*ctx ,*p;
	unsigned long len ,val ,cnt;
	unsigned long ipValue;

	strcpy_s( buf ,sizeof(buf) - 1 ,str );
	tok = strtok_s( buf ,"." ,&ctx );
	cnt = 0;
	ipValue = 0;
	while ( tok != NULL ) {
		if ( isDecimalNumberString( tok ) == 0 ) {
			break;
		}

		len = strlen( tok );
		if ( ( len == 0 ) || ( len > 3 ) ) {
			break;
		}

		val = strtol( tok ,&p ,10 );
		if ( val > 255 ) {
			break;
		}

		ipValue >>= 8;
		ipValue += ( val << 24 );
		tok = strtok_s( NULL ,"." ,&ctx );
		cnt++;
	}

	if ( cnt != 4 ) {
		return ( 1 );
	}

	*ip = ipValue;

	return ( 0 );
}

/*****************************************************************************
*				|[gԍ񂩂|[gԍ擾
* Fchar           *str  
*		unsigned short *port ʂԂϐւ̃|C^
* ߒlFint                  0:OK !0:NG
*****************************************************************************/
int aton_port_num( char *str ,unsigned short *port )
{
	char *p;
	int len;
	long value;

	if ( isDecimalNumberString( str ) == 0 ) {
		return ( 1 );
	}

	len = strlen( str );
	if ( ( len == 0 ) || ( len > 5 ) ) {
		return ( 2 );
	}

	value = strtol( str ,&p ,10 );
	if ( ( value <= 0L ) || ( value > 65535L ) ) {
		return ( 3 );
	}

	*port = htons( (unsigned short)value );
	return ( 0 );
}

/*****************************************************************************
*						zXgIPAhX擾
* Fchar          *str zXg
*		unsigned long *ip  ʂԂϐւ̃|C^
* ߒlFint                0:OK !0:NG
*****************************************************************************/
int host_ip_addr( char *str ,unsigned long *ip )
{
	HOSTENT *host = gethostbyname( str );
	if ( host == NULL ) {
		return ( 1 );
	}

	IN_ADDR *addr = (IN_ADDR *)host->h_addr_list[ 0 ];
	*ip = addr->S_un.S_addr;

	return ( 0 );
}

/*****************************************************************************
*							}WbNpPbgM
* Funsigned char  *mac_address WOLΏۋ@MACAhX(6bytes)
*       unsigned long  ip_address   IPAhX
*       unsigned short port_num     M|[gԍ( ʓI9gp )
* ߒlFint                         0:
*                                  !0:s
* ip_addressport_num̓oCgI[_[𒲐ĂĂт
******************************************************************************/
int send_magic_packet( unsigned char *mac_address ,unsigned long ip_address ,unsigned short port_num )
{
	int ret;
	int func_ret = 0;
	char send_datas[ HEADER_LENGTH + ( MAC_ADDRESS_LENGTH * REPEAT_COUNT ) ];
	SOCKET sok = INVALID_SOCKET;
	SOCKADDR_IN to_addr;

	/* }WbNpPbgf[^쐬			*/
	memset( send_datas ,0xff ,HEADER_LENGTH );
	for ( int i = 0 ;i < REPEAT_COUNT ;i++ ) {
		memcpy( &send_datas[ HEADER_LENGTH + ( i * MAC_ADDRESS_LENGTH ) ] ,mac_address ,MAC_ADDRESS_LENGTH );
	}

	/* MAhXE|[gԍݒ		*/
	memset( &to_addr ,0x00 ,sizeof(to_addr) );
	to_addr.sin_addr.s_addr = ip_address;
	to_addr.sin_port = port_num;
	to_addr.sin_family = AF_INET;

	/* UDP\Pbg						*/
	sok = socket( AF_INET ,SOCK_DGRAM ,0 );
	if ( sok == INVALID_SOCKET ) {
		fprintf( stderr ,"\Pbg̐Ɏs܂B(%d)\n" ,(int)sok );
		func_ret = 10;
		goto EXIT_send_magic_packet;
	}

	/* u[hLXg̃IvVݒ	*/
	if ( to_addr.sin_addr.s_addr == INADDR_BROADCAST ) {
		char opt = 1;
		ret = setsockopt( sok ,SOL_SOCKET ,SO_BROADCAST ,&opt ,sizeof(opt) );
		if ( ret != 0 ) {
			fprintf( stderr ,"\PbgIvV̐ݒɎs܂B(%d)\n" ,ret );
			func_ret = 11;
			goto EXIT_send_magic_packet;
		}
	}

	/* }WbNpPbgf[^M			*/
	ret = sendto( sok ,send_datas ,sizeof(send_datas) ,0 ,(struct sockaddr *)&to_addr, sizeof(to_addr) );
	if ( ret != sizeof(send_datas) ) {
		fprintf( stderr ,"}WbNpPbg̑MɎs܂B(%d)\n" ,ret );
		func_ret = 12;
		goto EXIT_send_magic_packet;
	}

EXIT_send_magic_packet:

	/* \PbgN[Y						*/
	if ( sok != INVALID_SOCKET ) {
		closesocket( sok );
	}

	return ( func_ret );
}

/*****************************************************************************
*							   C֐
* Fint argc      p[^̐
*       char *argv[]  p[^񃊃Xgւ̃|C^
* ߒlFint           0: !0:s
******************************************************************************/
int main( int argc, char *argv[] )
{
	unsigned char mac_address[ MAC_ADDRESS_LENGTH ];
	unsigned long ip_address;
	unsigned short port_num;
	char flgMac = 0 ,flgIp = 0 ,flgPort = 0;
	int hostIndex = -1;
	int func_ret = 0;
	WSADATA wsaData;

	fprintf( stderr ,"\nWOL(Wake on LAN) magic packet send application %s\n" ,APP_VERSION );

	/*								*/
	/* winsock̏				*/
	/*								*/
	if ( WSAStartup( MAKEWORD( USE_WINSOCK_VER ,0 ), &wsaData ) ) {
		fprintf( stderr ,"'WS2_32.DLL'܂'WSOCK32.DLL'ł܂B\n" );
		return ( 1 );
	}

	/*								*/
	/* ftHgp[^ݒ		*/
	/*								*/
	memset( mac_address ,0x00 ,MAC_ADDRESS_LENGTH );
	port_num = htons( DEFAULT_PORT );
	aton_ip_addr( DEFAULT_IP ,&ip_address );

	/*								*/
	/* ̃`FbNyю擾		*/
	/*								*/
	for ( int i = 1 ;i < argc ;i++ ) {
		if ( aton_mac_addr( argv[ i ] ,mac_address ) == 0 ) {	/* MACAhX擾	*/
			if ( flgMac ) {
				fprintf( stderr ,"MACAhXw肷邱Ƃ͂ł܂B\n" );
				func_ret = 2;
				goto EXIT_main;
			}
			flgMac = 1;

		} else if ( aton_ip_addr( argv[ i ] ,&ip_address ) == 0 ) {
			if ( flgIp ) {
				fprintf( stderr ,"IPAhXw肷邱Ƃ͂ł܂B\n" );
				func_ret = 3;
				goto EXIT_main;
			}
			flgIp = 1;

		} else if ( aton_port_num( argv[ i ] ,&port_num ) == 0 ) {
			if ( flgPort ) {
				fprintf( stderr ,"̃|[gԍw肷邱Ƃ͂ł܂B\n" );
				func_ret = 4;
				goto EXIT_main;
			}
			flgPort = 1;

		} else if ( host_ip_addr( argv[ i ] ,&ip_address ) == 0 ) {
			if ( flgIp ) {
				fprintf( stderr ,"IPAhXizXgjw肷邱Ƃ͂ł܂B\n" );
				func_ret = 5;
				goto EXIT_main;
			}
			hostIndex = i;
			flgIp = 1;

		} else {
			fprintf( stderr ,"Ȉ[%s]w肳܂B\n" ,argv[ i ] );
			func_ret = 6;
			goto EXIT_main;
		}
	}

	if ( ( flgIp || flgPort ) && !flgMac ) {
		fprintf( stderr ,"MACAhX̎w肪܂B\n" );
		func_ret = 7;
		goto EXIT_main;

	} else if ( !flgIp && !flgPort && !flgMac ) {
		fprintf( stderr ,"gp@ : magicpacket [MAC-Address] <IP-Address> <Port>\n" );
		fprintf( stderr ,"\n" );
		fprintf( stderr ,"[MAC-Address]ŋN@MACAhXw肵܂B\n" );
		fprintf( stderr ,"MACAhX̏ 00:00:00:00:00:00 ܂ 00-00-00-00-00-00 gpł܂B\n" );
		fprintf( stderr ,"MACAhX͏ȗł܂B\n" );
		fprintf( stderr ,"\n" );
		fprintf( stderr ,"<IP-Address>Ŏw肵IPAhXɃ}WbNpPbg𑗐M܂B\n" );
		fprintf( stderr ,"IPAhXȗƃu[hLXgőM܂B\n" );
		fprintf( stderr ,"IPAhX̑ɃzXgLq邱Ƃł܂B\n" );
		fprintf( stderr ,"\n" );
		fprintf( stderr ,"<Port>Ŏw肵|[gԍ֑M܂B\n" );
		fprintf( stderr ,"|[gԍȗƃ|[gԍ%dɑM܂B\n" ,DEFAULT_PORT );
		fprintf( stderr ,"\n" );
		fprintf( stderr ,"ep[^͔Cӂ̏ԂŎwł܂B\n" );
		func_ret = 8;
		goto EXIT_main;
	}

	/*								*/
	/* }WbNpPbgM			*/
	/*								*/
	func_ret = send_magic_packet( mac_address ,ip_address ,port_num );
	if ( func_ret != 0 ) {
		goto EXIT_main;
	}

	/*								*/
	/* bZ[W\			*/
	/*								*/
	if ( ip_address == INADDR_BROADCAST ) {
		fprintf( stderr ,"hoAhXFu[hLXg\n" );

	} else {
		IN_ADDR addr;
		addr.S_un.S_addr = ip_address;
		fprintf( stderr ,"hoAhXF%s" ,inet_ntoa( addr ) );
		if ( hostIndex != -1 ) {
			fprintf( stderr ,"(%s)" ,argv[ hostIndex ] );
		}
		fprintf( stderr ,"\n" );
	}

	fprintf( stderr ,"|[gԍ  F%u\n" ,htons( port_num ) );
	fprintf( stderr ,"l`bAhX  F%02X-%02X-%02X-%02X-%02X-%02X\n" ,mac_address[0] ,mac_address[1] ,mac_address[2] ,mac_address[3] ,mac_address[4] ,mac_address[5] );
	fprintf( stderr ,"}WbNpPbg𑗐M܂B\n" );

EXIT_main:

	/*								*/
	/* winsock̉				*/
	/*								*/
	WSACleanup();

	return ( func_ret );
}
